// Meister.cc: Implementierung der Klasse CMeister.
//
//////////////////////////////////////////////////////////////////////

#include "stdio.h"
#include "iostream.h"
#include "Meister.h"
#include "stdlib.h"
#include <string>


//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CMeister::CMeister(string strName)
{
	m_plistRaum = new CList<CRaum *>;
	m_plistGegenstand = new CList<CGegenstand *>;
	m_plistInventar = new CList<CGegenstand *>;

	m_pSpieler = NULL;
	m_praumBeginn = NULL;
	m_praumEnde = NULL;

	m_pstrName = new string(strName);

}

CMeister::~CMeister()
{
	CRaum * pRaum;
	CGegenstand * pGegenstand;

	while(m_plistRaum->RemoveData(1, pRaum))
		delete pRaum;
	while(m_plistGegenstand->RemoveData(1, pGegenstand))
		delete pGegenstand;

	delete m_plistRaum;
	delete m_plistGegenstand;
	delete m_plistInventar;
	if (m_pSpieler)
		delete m_pSpieler;
	delete m_pstrName;
}


int CMeister::GetName (string & strName)
{
	strName = *m_pstrName;
	return 0;
}


int CMeister::Start ()
{
//	Nachrichtenschleife fuer Labyrintherstellung und Testspiel
	char ch;
	int loop = 1;

	while(loop)
	{
		cout << endl;
		cout << "**************************************************************\n";
		cout << "*Rollenspiel - Testengine                                    *\n";
		cout << "*(c) 1998 by Torben Nehmer, Wolfgang Nitz, u.a.              *\n";
		cout << "**************************************************************\n\n";
		cout << "[ 1 ] Raum erstellen\n";
		cout << "[ 2 ] Raum loeschen\n";
		cout << "[ 3 ] Raum zuordnen\n";
		cout << "[ 4 ] Gegenstand erstellen\n";
		cout << "[ 5 ] Gegenstand loeschen\n";
		cout << "[ 6 ] Gegenstand zuordnen\n";
		cout << "[ 7 ] Start- und Endraum waehlen\n";
		cout << "[ 8 ] Spieler anlegen\n";
		cout << "[ 9 ] Spieler loeschen\n";
		cout << "[ 0 ] Testspiel starten\n";
		cout << "[ R ] Raumliste anzeigen\n";
		cout << "[ G ] Gegenstandsliste anzeigen\n";
		cout << "[ X ] Beenden\n\n";
		cout << "Choose your destination: ";		
		
		
		cin >> ch;

		switch(toupper(ch))
		{
		case '1':
			msgRaumErstellen();
			break;
		case '2':
			msgRaumLoeschen();
			break;
		case '3':
			msgRaumZuordnen();
			break;
		case '4':
			msgGegenstandErstellen();
			break;
		case '5':
			msgGegenstandLoeschen();
			break;
		case '6':
			msgGegenstandZuordnen();
			break;
		case '7':
			msgStartEnde();
			break;
		case '8':
			msgSpielerAnlegen();
			break;
		case '9':
			msgSpielerLoeschen();
			break;
		case '0':
			msgSpielstart();
			break;
		case 'R':
			msgRaumListe();
			break;
		case 'G':
			msgGegenstandListe();
			break;
		case 'X':
			loop = 0;
			break;
		default:
			break;
		}
	}	
}

int CMeister::msgRaumErstellen()
{
	CRaum * pNew;
	string str;

	cout << "\n\n\n";
	cout << "Raum anlegen:\n";
	cout << "=============\n";
	cout << "Bitte geben sie den Namen des neuen Raumes an: ";
	cin >> str;

	pNew = new CRaum (str);
	m_plistRaum->AddData(pNew);

	return 0;
}

int CMeister::msgRaumLoeschen()
{
	CRaum * pDel;
	CRaum * pTemp;
	CRaum * pTemp2;
	int i,j;

	if (m_plistRaum->IsEmpty())
	{
		cout << "\n\n\nDie Liste enthlt keine Elemente!\n";
		return 1;
	}

	cout << "\n\n\n";
	cout << "Raum loeschen:\n";
	cout << "==============\n";
	msgRaumListe();
	cout << "Nummer des zu loeschenden Raumes eingeben: ";
	cin >> i;
	cout << endl;

	if (m_plistRaum->RemoveData(i, pDel))
		delete pDel;
	else
		return 2;

	i = 0;
	while(m_plistRaum->GetData(++i, pTemp))
	{
		j = 0;
		while(!pTemp->GetRaum(++j, pTemp2))
		{
			if (pTemp2 == pDel)
			{
				pTemp->RemoveRaum(j, pTemp2);
				j--;
			}
		}
	}
	return 0;
}

int CMeister::msgRaumZuordnen()
{
	CRaum * pSource;
	CRaum * pDest;
	int i;

	if (m_plistRaum->IsEmpty())
	{
		cout << "Es waere ratsam, zuerst einen Raum anzulegen...\n";
		return 2;
	}

	cout << "\n\n\n";
	cout << "Raum zuordnen:\n";
	cout << "==============\n";
	msgRaumListe();
	cout << "Bitte waehlen Sie die Nummer des Ursprungsraum der Verbindung: ";
	cin >> i;
	cout << endl;
	if (m_plistRaum->GetData(i, pSource))
		cout << "Herzlichen Glueckwunsch, dieser Raum existiert tatsaechlich!\n";
	else
	{
		cout << "Herzlichen Glueckwunsch, dieser Raum existiert LEIDER NICHT!\n";
		return 1;
	}

	msgRaumListe();
	cout << "Bitte waehlen Sie die Nummer des Zielraums der Verbindung: ";
	cin >> i;
	cout << endl;
	if (m_plistRaum->GetData(i, pDest))
		cout << "Herzlichen Glueckwunsch, auch dieser Raum existiert tatsaechlich!\n";
	else
	{
		cout << "Herzlichen Glueckwunsch, dieser Raum existiert LEIDER NICHT!\n";
		return 2;
	}
	
	pSource->AddRaum(pDest);
	return 0;
}

int CMeister::msgGegenstandErstellen()
{
	CGegenstand * pNew;
	string str;

	cout << "\n\n\n";
	cout << "Gegenstand anlegen:\n";
	cout << "===================\n";
	cout << "Bitte geben sie den Namen des neuen Gegenstandes an: ";
	cin >> str;

	pNew = new CGegenstand (str);
	m_plistGegenstand->AddData(pNew);

	return 0;

}

int CMeister::msgGegenstandLoeschen()
{
	CGegenstand * pDel;
	CRaum * pTemp;
	CGegenstand * pTemp2;

	int i,j;

	if (m_plistGegenstand->IsEmpty())
	{
		cout << "\n\n\nDie Liste enthlt keine Elemente!\n";
		return 1;
	}

	cout << "\n\n\n";
	cout << "Gegenstand loeschen:\n";
	cout << "====================\n";
	msgGegenstandListe();
	cout << "Nummer des zu loeschenden Gegenstandes eingeben: ";
	cin >> i;
	cout << endl;

	if (m_plistGegenstand->RemoveData(i, pDel))
		delete pDel;

	else
		return 2;

	i = 1;
	while(m_plistRaum->GetData(i, pTemp))
	{
		j = 1;
		while(!pTemp->GetGegenstand(j, pTemp2))
		{
			if (pTemp2 == pDel)
			{
				pTemp->RemoveGegenstand(j, pTemp2);
				j--;
			}
			j++;
		}
		i++;
	}

	i = 1;
	while (m_plistInventar->GetData(i, pTemp2))
	{
		if (pTemp2 == pDel)
		{
			m_plistInventar->RemoveData(i, pTemp2);
			i--;
		}
		i++;
	}

	return 0;
}

int CMeister::msgGegenstandZuordnen()
{
	CGegenstand * pSource;
	CGegenstand * pGegenstand;
	CRaum * pDest;
	int i;
	char ch;

	cout << "\n\n\n";
	cout << "Gegenstand zuordnen:\n";
	cout << "====================\n";
	msgGegenstandListe();
	cout << "Bitte waehlen Sie die Nummer des Gegenstandes: ";
	cin >> i;
	cout << endl;
	if (m_plistGegenstand->GetData(i, pSource))
		cout << "Herzlichen Glueckwunsch, dieser Gegenstand existiert tatsaechlich!\n";
	else
	{
		cout << "Herzlichen Glueckwunsch, dieser Gegenstand hat sich wohl in Rauch AUFGELOEST!\n";
		return 1;
	}

	cout << "Wenn Sie den Gegenstand einem Spieler zuordnen wollen, dann druecken sie JETZT ein [J]: ";
	cin >> ch;

	if (toupper(ch) == 'J')
	{
		i = 0;
		while (m_plistInventar->GetData(++i, pGegenstand))
			if (pGegenstand == pSource)
				return 0;
			
		m_plistInventar->AddData(pSource);
		return 0;
	}
	
	if (m_plistRaum->IsEmpty())
	{
		cout << "Es waere ratsam, zuerst einen Raum anzulegen...\n";
		return 2;
	}

	msgRaumListe();
	cout << "Bitte waehlen Sie die Nummer des Raumes: ";
	cin >> i;
	cout << endl;
	if (m_plistRaum->GetData(i, pDest))
		cout << "Herzlichen Glueckwunsch, auch dieser Raum existiert tatsaechlich!\n";
	else
	{
		cout << "Herzlichen Glueckwunsch, dieser Raum existiert LEIDER NICHT!\n";
		return 3;
	}

	i = 0;
	while (!pDest->GetGegenstand(++i, pGegenstand))
		if (pGegenstand == pSource)
			return 0;

	
	pDest->AddGegenstand(pSource);
	return 0;

}

int CMeister::msgStartEnde()
{
	cout << "\n\n\n";
	cout << "Start- und Endraum festlegen:";
	cout << "=============================";

	if(m_plistRaum->IsEmpty())
	{
		cout << "Es waere ratsam zuerst ein paar Raeume anzulegen...\n";
		return 1;
	}

	CRaum * pStart;
	CRaum * pEnde;
	int i;

	msgRaumListe();
	cout << "Bitte geben Sie die Nummer des Startraumes ein: ";
	cin >> i;
	cout << endl;

	if (m_plistRaum->GetData(i, pStart))
		cout << "Herzlichen Glueckwunsch, sie haben einen existierenden Raum getroffen!\n";
	else
	{
		cout << "Diese Raumnummer existiert nicht!\n";
		return 2;
	}

	msgRaumListe();
	cout << "Bitte geben Sie die Nummer des Zielraumes ein: ";
	cin >> i;
	cout << endl;

	if (m_plistRaum->GetData (i, pEnde))
		cout << "Herzlichen Glueckwunsch, auch dieser Raum existiert! Ob er Zugaenge 
			hat,\nsteht auf einem anderen Blatt\n";
	else
	{
		cout << "Diese Raumnummer existiert nicht!\n";
		return 3;
	}

	m_praumBeginn = pStart;
	m_praumEnde = pEnde;

	cout << "Genial. Sie haben die Zuweisung eines Start- und Endraumes erfolgreich\n
		vollzogen!\n";
	return 0;

}

int CMeister::msgSpielerAnlegen()
{
	string str;

	cout << "\n\n\n";
	cout << "Spieler anlegen:\n";
	cout << "================\n";

	if (m_pSpieler)
	{
		cout << "Es ist bereits ein Spieler angelegt. Toeten Sie diesen zuerst!\n";
		return 1;
	}

	cout << "Bitte geben Sie den Namen des Spielers ein. Aehnlichkeiten mit Lebenden\n
		Personen sind nicht ausgeschlossen, aber rein zufaellig: ";
	cin >> str;

	m_pSpieler = new CSpieler(str, this);

	return 0;
}

int CMeister::msgSpielerLoeschen()
{
	cout << "\n\n\n";
	cout << "Spieler toeten:\n";
	cout << "===============\n";

	if (!m_pSpieler)
	{
		cout << "Beschaeftigst Du Dich immer mit Schattenboxen? Hier existiert niemand,\n
			der kaputtbar waere...\n";
		return 1;
	}
	cout << "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAARRRRRRRRRRRRRRRRRRRRRRRGHHHHHHHH!\n";
	cout << "<plumps> Ein regloser Koerper schlaegt auf dem Boden auf und wird vom\n
		Aufraeumdienst nach NIL (ode NUL, je nach System) verschoben.\n";

	cout << "\nWaren Sie sich auch wirklich sicher !?!\n";
	delete m_pSpieler;
	m_pSpieler = NULL;
	return 0;
}

int CMeister::msgSpielstart()
{
	if (!m_pSpieler)
	{
		cout << "Es existiert kein Spieler!\n";
		return 1;
	}
	if (!m_praumBeginn || !m_praumEnde)
	{
		cout << "Start- oder Endraum nicht definert!\n";
		return 2;
	}
	
	CList<CGegenstand *> * plistTemp = new CList<CGegenstand *>;
	CGegenstand * pGegenstand;

	while (m_plistInventar->RemoveData(1, pGegenstand))
		plistTemp->AddData(pGegenstand);

	m_pSpieler->Start(m_praumBeginn, plistTemp);

	while (plistTemp->RemoveData(1, pGegenstand))
		m_plistInventar->AddData(pGegenstand);

	delete plistTemp;
	return 0;
}

int CMeister::msgRaumListe()
{
	int iCount = 0;
	int iLine = 2;
	CRaum * pTemp;
	char ctemp;

	cout << "\n\n\n";

	cout << "Liste der Raeume:\n";
	cout << "=================\n";

	while (m_plistRaum->GetData(++iCount, pTemp))
	{
        	cout << iCount << ": " << pTemp->GetName() << endl;
		iLine++;
		if (iLine >= 23)
		{
			cout << "Eine Taste fuer weiter...\n";
			iLine = 0;
			cin >> ctemp;
		}
	}
	cout << "Eine Taste fuer weiter...\n";
	cin >> ctemp;
	return 0;
}

int CMeister::msgGegenstandListe()
{
	int iCount = 0;
	int iLine = 2;
	char ctemp;
	CGegenstand * pTemp;

	cout << "\n\n\n";

	cout << "Liste der Gegenstaende:\n";
	cout << "=======================\n";

	while (m_plistGegenstand->GetData(++iCount, pTemp))
	{
        	cout << iCount << ": " << pTemp->GetName() << endl;
		iLine++;
		if (iLine >= 23)
		{
			cout << "Eine Taste fuer weiter...\n";
			iLine = 0;
			cin >> ctemp;
		}
	}
	cout << "Eine Taste fuer weiter...\n";
	cin >> ctemp;
	return 0;
}

int CMeister::CheckEnde (CRaum * pRaum)
{
	return (pRaum == m_praumEnde);
}
