// Meister.h: Schnittstelle fr die Klasse CMeister.
//
//////////////////////////////////////////////////////////////////////

#if !defined(MEISTER_H)
#define MEISTER_H

// Includes
#include "CList.h"
#include "Gegenstand.h"
#include "Spieler.h"
#include "Raum.h"
#include <string>

class CSpieler;

class CMeister  
{
private:
//////////////////////////////////////////////////////////////////////////
// Verwaltungsdaten
//

	CSpieler * m_pSpieler;

	CList<CRaum *> * m_plistRaum;
	
	CList<CGegenstand *> * m_plistGegenstand;
	CList<CGegenstand *> * m_plistInventar;


	CRaum * m_praumBeginn;
	CRaum * m_praumEnde;

	string * m_pstrName;


//////////////////////////////////////////////////////////////////////////
// Nachrichtenschleife fuer Start
//
	virtual int msgSpielstart();
	virtual int msgSpielerLoeschen();
	virtual int msgSpielerAnlegen();
	virtual int msgStartEnde();
	virtual int msgGegenstandZuordnen();
	virtual int msgGegenstandLoeschen();
	virtual int msgGegenstandErstellen();
	virtual int msgRaumZuordnen();
	virtual int msgRaumLoeschen();
	virtual int msgRaumErstellen();
	virtual int msgGegenstandListe();
	virtual int msgRaumListe();

public:
//////////////////////////////////////////////////////////////////////////
// Konstruktor / Destruktior
//
	CMeister(string strName);
	virtual ~CMeister();


//////////////////////////////////////////////////////////////////////////
// Zugriffsfunktionen
//
	virtual int GetName (string & strName);
	virtual int CheckEnde (CRaum * pRaum);

//////////////////////////////////////////////////////////////////////////
// Funktionen fuer Labyrinttest
// Meister uebernimmt Bildschirm- / Tastaturkontrolle
// und liefert 0 zurueck, wenn Spiel ordnungsgemaess beendet, !(0) wenn 
// ein Fehler aufgetreten ist.
// Funktionen:
// * Raeume anlegen / loeschen / konfigurieren
// * Gegenstaende anlegen / loeschen / konfigurieren
// * Anfang / Ziel festlegen
// * Testspiel starten

	virtual int Start ();

};

#endif // !defined(MEISTER_H)


