// Raum.cc: Implementierung der Klasse CRaum.
//
//////////////////////////////////////////////////////////////////////

#include "CList.h"
#include "Raum.h"
#include "Gegenstand.h"

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CRaum::CRaum(string strName)
{
	m_pstrName = new string (strName);
	m_plistGegenstand = new CList<CGegenstand *>;
	m_plistRaum = new CList<CRaum *>;
}

CRaum::~CRaum()
{
	delete m_pstrName;
	delete m_plistGegenstand;
	delete m_plistRaum;
}


string CRaum::GetName ()
{
	return (*m_pstrName);
}

int CRaum::AddRaum (CRaum * pRaum)
{
	m_plistRaum->AddData(pRaum);
	return 0;
}

int CRaum::GetRaum (int iPos, CRaum * & pRaum)
{
	return !(m_plistRaum->GetData(iPos, pRaum));
}

int CRaum::RemoveRaum (int iPos, CRaum * & pRaum)
{
	return !(m_plistRaum->RemoveData(iPos, pRaum));
}

int CRaum::AddGegenstand (CGegenstand * pGegenstand)
{
	m_plistGegenstand->AddData(pGegenstand);
	return 0;
}

int CRaum::GetGegenstand (int iPos, CGegenstand * & pGegenstand)
{
	return !(m_plistGegenstand->GetData(iPos, pGegenstand));
}

int CRaum::RemoveGegenstand (int iPos, CGegenstand * & pGegenstand)
{
	return !(m_plistGegenstand->RemoveData(iPos, pGegenstand));
}



